
#include <fpe.h>

/*

bit positions:

nan	1
i	2
z	4
n	8

*/

#define ORDERED		0b0101010101010101
#define UNORDERED	0b1010101010101010
#define EQ		0b1111000011110000
#define NE		0b0000111100001111
#define LT		0b1111111100000000
#define GT		0b0000000011111111

int cc_table[]=
{
/* 00000 f	*/	0,
/* 00001 eq	*/	EQ,
/* 00010 ogt	*/	ORDERED & GT,
/* 00011 oge	*/	(ORDERED & GT) | EQ,
/* 00100 olt	*/	ORDERED & LT,
/* 00101 ole	*/	(ORDERED & LT) | EQ,
/* 00110 ogl	*/	ORDERED & NE,
/* 00111 or	*/	ORDERED,
/* 01000 un	*/	UNORDERED,
/* 01001 ueq	*/	UNORDERED | EQ,
/* 01010 ugt	*/	UNORDERED | GT,
/* 01011 uge	*/	UNORDERED | GT | EQ,
/* 01100 ult	*/	UNORDERED | LT,
/* 01101 ule	*/	UNORDERED | LT | EQ,
/* 01110 ne	*/	NE,
/* 01111 t	*/	EQ | NE
}

int judge_condition(int cc)
{
	return cc_table[cc&0xf] & ( 1 << flags );
}


void fpe_bcc(void)
{
	int32 disp;
	
	if( instr0 & (1<<6) ){	/* displacement size */
		disp=*pc_int32;
		pc+=4;
	}else{
		disp=*pc_int16;
		pc+=2;
	}
	if(judge_condition(instr0 & 0x3f)){
		pc+=disp;
	}
}

void fpe_dbcc(void)
{
	int32 disp;
	
	disp=*pc_int16;
	pc+=2;
	if(judge_condition(instr1 & 0x3f))return;
	
	if((--dn[ instr0 & 7 ])==-1)return;
	
	pc+=disp;
}

void fpe_scc(void)
{
	int byte;

	byte=judge_condition(instr1 & 0x3f) ? 0xff : 0;
	
	writeb_effective_address(byte, instr0 & 0x3f );
}

