
#ifndef _FPE_H
#define _FPE_H

#define LITTLE_ENDIAN

typedef unsigned int uint32;
typedef int int32;
typedef short int16;


struct fpe_register_struct{
	
	uint32 man_hi;
	uint32 man_lo;
	int sign;
	int exp;
	
};
typedef struct fpe_register_struct fpe_register;

struct fpe_result_struct{
	
	uint32 man_overflow;
	uint32 man_hi;
	uint32 man_lo;
	uint32 man_underflow;
	int sign;
	int exp;
	
};
typedef struct fpe_result_struct fpe_result;

struct fpe_struct{
	uint16 instr0;
	uint16 instr1;
	void *pc;
	fpe_register fpreg[8];
	fpe_register fpreg_tmp;
	
	fpe_register *src_register,*dest_register;
};


/* entrance for fpe routines */
int fpe_enter(void *pc,uint16 ccr);

/* determine truth of condition */
int judge_condition(int condition_code);

/* copy result register to destination, normalizing on the way */
void normalize(fpe_register *dest);

/* conversion between formats */
void reg_to_double(fpe_register *,uint32 *);
void double_to_reg(fpe_register *,uint32 *);

void dump_register(fpe_register *);
void dump_result(fpe_result *);
void dump_double(double);


void mul(fpe_register *,fpe_register *);
void add(fpe_register *,fpe_register *);
void sub(fpe_register *,fpe_register *);

void mantissa_rol(unsigned bits,uint32 *hi,uint32 *lo);
void mantissa_ror(unsigned bits,uint32 *hi,uint32 *lo);

void normalize(fpe_register *);

extern fpe_result *result;


#define pc_int32	((int32 *)pc)
#define pc_uint32	((uint32 *)pc)
#define pc_int16	((int16 *)pc)
#define pc_uint16	((uint16 *)pc)


#endif

