
#define D0	0
#define D1	4
#define D2	8
#define D3	12
#define D4	16
#define D5	20
#define D6	24
#define D7	28
#define A0	32
#define A1	36
#define A2	40
#define A3	44
#define A4	48
#define A5	52
#define A6	56
#define A7	60
#define VEC	64
#define PC	66
#define SR	70


#ifndef MODULE
#define printk	printf
#define moves_l	move.l
#define moves_w	move.w
#define moves_b move.b
#else
#define moves_l	moves.l
#define moves_w	moves.w
#define moves_b moves.b
#endif

#define P(str)					\
	movem.l	%d0/%d1/%a0/%a1,-(%sp);		\
	pea	9f;				\
	jsr	printk;				\
	addql	&4,%sp;				\
	movem.l	(%sp)+,%d0/%d1/%a0/%a1;		\
	jra	0f;				\
9:	.ascii	str, "\n\0";			\
	.align	4;				\
0:

#define PF(str,addr)				\
	movem.l	%d0/%d1/%a0/%a1,-(%sp);		\
	lea	addr,%a0;			\
	move.l	(8,%a0),-(%sp);			\
	move.l	(4,%a0),-(%sp);			\
	move.l	(%a0),-(%sp);			\
	pea	9f;				\
	jsr	printk;				\
	lea	(16,%sp),%sp;			\
	movem.l	(%sp)+,%d0/%d1/%a0/%a1;		\
	jra	0f;				\
9:	.ascii	str,": %08x %08x %08x\n\0";	\
	.align	4;				\
0:


#define P1(str,nr)				\
	movem.l	%d0/%d1/%a0/%a1,-(%sp);		\
	move.l	nr,-(%sp);			\
	pea	9f;				\
	jsr	printk;				\
	addql	&8,%sp;				\
	movem.l	(%sp)+,%d0/%d1/%a0/%a1;		\
	jra	0f;				\
9:	.ascii	str, "\n\0";			\
	.align	4;				\
0:

#define P2(str,n1,n2)				\
	movem.l	%d0/%d1/%a0/%a1,-(%sp);		\
	move.l	n2,-(%sp);			\
	move.l	n1,-(%sp);			\
	pea	9f;				\
	jsr	printk;				\
	lea	(12,%sp),%sp;			\
	movem.l	(%sp)+,%d0/%d1/%a0/%a1;		\
	jra	0f;				\
9:	.ascii	str, "\n\0";			\
	.align	4;				\
0:

#define P3(str,n1,n2,n3)			\
	movem.l	%d0/%d1/%a0/%a1,-(%sp);		\
	move.l	n3,-(%sp);			\
	move.l	n2,-(%sp);			\
	move.l	n1,-(%sp);			\
	pea	9f;				\
	jsr	printk;				\
	lea	(16,%sp),%sp;			\
	movem.l	(%sp)+,%d0/%d1/%a0/%a1;		\
	jra	0f;				\
9:	.ascii	str, "\n\0";			\
	.align	4;				\
0:

#define P4(str,n1,n2,n3,n4)			\
	movem.l	%d0/%d1/%a0/%a1,-(%sp);		\
	move.l	n4,-(%sp);			\
	move.l	n3,-(%sp);			\
	move.l	n2,-(%sp);			\
	move.l	n1,-(%sp);			\
	pea	9f;				\
	jsr	printk;				\
	lea	(20,%sp),%sp;			\
	movem.l	(%sp)+,%d0/%d1/%a0/%a1;		\
	jra	0f;				\
9:	.ascii	str, "\n\0";			\
	.align	4;				\
0:

#define get_fpsr(reg)				\
	lea	(fpe_sr,%pc),reg

#define get_fpcr(reg)				\
	lea	(fpe_cr,%pc),reg

#define get_fpiar(reg)				\
	lea	(fpe_iar,%pc),reg

#define encode_addrmode(reg)			\
	bfextu	%d6{&10,&3},reg

#define encode_addrreg(reg)			\
	bfextu	%d6{&13,&3},reg

#define test_byte_sp_transf(reg, size)		\
	move.l	%d5,size;			\
	cmp.w	&7,reg;				\
	jne	0f;				\
	cmp.w	&6,size;			\
	jne	0f;				\
	moveq	&4,size;			\
0:

#define do_post_inc(size, tmp)			\
	move.l	%a0,tmp;			\
	add.w	(fp_datasize,size*2),%a0;	\
	jsr	fp_put_addr_reg;		\
	move.l	tmp,%a0

#define do_pre_decr(size)			\
	sub.w	(fp_datasize,size*2),%a0;	\
	jsr	fp_put_addr_reg

#define test_basereg_d16()			\
	btst	&20,%d6

#define test_basereg_ext()			\
	btst	&19,%d6

#define do_disp16(tmp, reg)			\
	moves.w	(%a5)+,tmp;			\
	lea	(reg,tmp),reg

#define get_extword()				\
	moves.w	(%a5)+,%d4

#define test_exttype()				\
	btst	&8,%d4

#ifndef DEBUG
#define encode_index(tmp, reg)			\
	bfextu	%d4{&17,&3},%d0;		\
	btst	&15,%d4;			\
	jne	1f;				\
	jsr	fp_get_data_reg;		\
	jra	2f;				\
1:	jsr	fp_get_addr_reg;		\
	move.l	%a0,reg;			\
2:	btst	&11,%d4;			\
	jne	1f;				\
	ext.l	reg;				\
1:	bfextu	%d4{&21,&2},tmp;		\
	lsl.l	tmp,reg
#else
#define encode_index(tmp, reg)			\
	bfextu	%d4{&17,&3},%d0;		\
	move.l	%d0,%a3;			\
	btst	&15,%d4;			\
	jne	1f;				\
	jsr	fp_get_data_reg;		\
	moveq	&'d',%d2;			\
	jra	2f;				\
1:	jsr	fp_get_addr_reg;		\
	move.l	%a0,reg;			\
	moveq	&'a',%d2;			\
2:	move.l	%d2,%a2;			\
	moveq	&'l',%d2;			\
	btst	&11,%d4;			\
	jne	1f;				\
	moveq	&'w',%d2;			\
	ext.l	reg;				\
1:	bfextu	%d4{&21,&2},tmp;		\
	lsl.l	tmp,reg;			\
	moveq	&1,%d3;				\
	lsl.l	%d1,%d3;			\
	P4("index %c%d.%c*%d", %a2, %a3, %d2, %d3)
#endif	

#define do_disp8(sreg, dreg, tmp)		\
	bfexts	%d4{&24,&8},tmp;		\
	P1("disp8 %x", tmp);			\
	lea	(sreg,tmp),dreg
	
#define test_suppr_base()			\
	btst	&7,%d4

#define encode_basesize(reg)			\
	bfextu	%d4{&26,&2},reg

#define get_base16(areg)			\
	moves.w	(%a5)+,areg;			\
	P1("disp16 %x", areg)

#define get_base32(areg)			\
	moves.l	(%a5)+,areg;			\
	P1("disp32 %x", areg)

#define do_preindex(idx, tmp)			\
	moveq	&3,tmp;				\
	and.w	%d4,tmp;			\
	jeq	1f;				\
	btst	&2,%d4;				\
	jne	1f;				\
	P("indirect preindexed");		\
	moves.l	(idx),idx;			\
1:

#define test_suppr_index()			\
	btst	&6,%d4

#define do_postindex(idx)			\
	btst	&2,%d4;				\
	jeq	1f;				\
	P("indirect postindexed");		\
	moves.l	(%a1),%a1;			\
1:

#define encode_outersize(reg)			\
	bfextu	%d4{&30,&2},reg

#define get_outer16(areg)			\
	moves.w	(%a5)+,areg;			\
	P1("odisp16 %x", areg)

#define get_outer32(areg)			\
	moves.l	(%a5)+,areg;			\
	P1("odisp32 %x", areg)

#define get_abs_short(areg)			\
	moves.w	(%a5)+,areg;			\
	P1("(%x)", areg)

#define get_abs_long(areg)			\
	moves.l	(%a5)+,areg;			\
	P1("(%x)", areg)



