#include "fp.h"

	.globl	fp_fpscc, fp_fpbccw, fp_fpbccl

fp_fpbccw:
	P("fpbccw")
	subq.l	#2,%a5
	moves_w	(%a5)+,%a1
	jra	1f

fp_fpbccl:
	P("fpbccl")
	subq.l	#2,%a5
	moves_l	(%a5)+,%a1
1:	move.l	%d6,%d0
	swap	%d0
	jsr	fp_compute_cond
	tst.l	%d0
	jeq	1f
	jsr	fp_get_pc
	P2("pc: %p %p", %a0, %a1)
	lea	(2,%a0,%a1),%a0
	jsr	fp_put_pc
1:	jra	fp_end

fp_fpscc:
	P("fpscc")
	move.l	%d6,%d0
	jsr	fp_compute_cond
	move.l	%d0,%d5

	| encode addressing mode
	encode_addrmode(%d0)
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
	.long 	fp_data, fp_ill
	.long 	fp_indirect, fp_postinc
	.long 	fp_predecr, fp_disp16
	.long 	fp_extmode0, fp_extmode1

	| addressing mode: data register direct
fp_data:
	encode_addrreg(%d0)
	move.l	%d0,%d1
	P1("source d%d", %d0)
	jsr	fp_get_data_reg
	move.b	%d5,%d0
	jsr	fp_put_data_reg
	jra	fp_end

fp_indirect:
	encode_addrreg(%d0)
	P1("source (a%d)", %d0)
	jsr	fp_get_addr_reg
	move.b	%d5,(%a0)
	jra	fp_end

fp_postinc:
	encode_addrreg(%d0)
	moveq	#0,%d1
	cmp.w	#7,%d0
	jne	1f
	moveq	#1,%d1
1:	P1("source (a%d)+", %d0)
	jsr	fp_get_addr_reg
	move.b	%d5,(%a0)+
	add.l	%d1,%a0
	jsr	fp_put_addr_reg
	jra	fp_end

fp_predecr:
	encode_addrreg(%d0)
	moveq	#0,%d1
	cmp.w	#7,%d0
	jne	1f
	moveq	#1,%d1
1:	P1("source -(a%d)", %d0)
	jsr	fp_get_addr_reg
	add.l	%d1,%a0
	move.b	%d5,-(%a0)
	jsr	fp_put_addr_reg
	jra	fp_end

fp_disp16:
	encode_addrreg(%d0)
#ifdef DEBUG
	moves_w	(%a5),%d1
	ext.l	%d1
	P2("source (%x,a%d)", %d1, %d0)
#endif
	jsr	fp_get_addr_reg
	moves_w	(%a5)+,%d0
	move.b	%d5,(%a0,%d0.w)
	jra	fp_end

fp_extmode0:
	get_extword()
	test_exttype()
	jne	fp_fullext

	encode_addrreg(%d0)
	P1("base a%d", %d0)
	jsr	fp_get_addr_reg
	move.l	%a0,%a1
	encode_index(%d1, %d0)
	add.l	%d0,%a1
	bfexts	%d4{#24,#8},%d0
	P1("disp8 %x", %d0)
	move.b	%d5,(%a1,%d0.l)
	jra	fp_end

fp_fullext:
	sub.l	%a1,%a1
	test_suppr_base()		| base register suppressed?
	jne	1f
	encode_addrreg(%d0)
	P1("base a%d", %d0)
	jsr	fp_get_addr_reg
	move.l	%a0,%a1
#ifdef DEBUG
	jra	2f
1:	P("base register suppresed")
2:
#else
1:
#endif
	encode_basesize(%d0)
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
#ifdef DEBUG
	.long	fp_ill, fp_base0
	.long	fp_base16, fp_base32

fp_base0:
	P("no disp")
	jra	fp_outer
#else
	.long	fp_ill, fp_outer
	.long	fp_base16, fp_base32
#endif

fp_base16:
	get_base16(%a0)
	jra	1f

fp_base32:
	get_base32(%a0)
1:	add.l	%a0,%a1

fp_outer:
	do_preindex(%a1, %d0)
	test_suppr_index()		| index register suppressed?
	jne	fp_postindex
	encode_index(%d1, %d0)
	add.l	%d0,%a1

fp_postindex:
	do_postindex(%a1)

	encode_outersize(%d0)
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
#ifdef DEBUG
	.long	fp_fullext_fin, fp_outer0
	.long	fp_outer16, fp_outer32

fp_outer0:
	P("no odisp")
	jra	fp_fullext_fin
#else
	.long	fp_fullext_fin, fp_fullext_fin
	.long	fp_outer16, fp_outer32
#endif

fp_outer16:
	get_outer16(%a0)
	jra	1f

fp_outer32:
	get_outer32(%a0)
1:	add.l	%a0,%a1

fp_fullext_fin:
	move.b	%d5,(%a1)
	jra	fp_end

fp_extmode1:
	bfextu	%d6{#13,#3},%d0
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
	.long	fp_absolute_short, fp_absolute_long
	.long	fp_ill, fp_ill
	.long	fp_ill, fp_ill
	.long	fp_ill, fp_ill

fp_absolute_short:
	get_abs_short(%a0)
	move.b	%d5,(%a0)
	jra	fp_end

fp_absolute_long:
	get_abs_long(%a0)
	move.b	%d5,(%a0)
	jra	fp_end


fp_compute_cond:
	get_fpsr(%a0)
	move.l	(%a0),%d5
	moveq	#0xf,%d1
	and.l	%d0,%d1
	exg	%d0,%d1
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
	.long	fp_f  , fp_eq , fp_ogt, fp_oge
	.long	fp_olt, fp_ole, fp_ogl, fp_or
	.long	fp_un , fp_ueq, fp_ugt, fp_uge
	.long	fp_ult, fp_ule, fp_ne , fp_t

#define tst_NAN	btst #24,%d5
#define tst_Z	btst #26,%d5
#define tst_N	btst #27,%d5

fp_f:
	moveq	#0,%d0
	jra	fp_bsun

fp_eq:
	moveq	#0,%d0
	tst_Z
	jeq	1f
	moveq	#-1,%d0
1:	jra	fp_bsun

fp_ogt:
	moveq	#0,%d0
	tst_NAN
	jne	1f
	tst_Z
	jne	1f
	tst_N
	jne	1f
	moveq	#-1,%d0
1:	jra	fp_bsun

fp_oge:
	moveq	#-1,%d0
	tst_Z
	jne	2f
	tst_NAN
	jne	1f
	tst_N
	jeq	2f
1:	moveq	#0,%d0
2:	jra	fp_bsun

fp_olt:
	moveq	#0,%d0
	tst_NAN
	jne	1f
	tst_Z
	jne	1f
	tst_N
	jeq	1f
	moveq	#-1,%d0
1:	jra	fp_bsun

fp_ole:
	moveq	#-1,%d0
	tst_Z
	jne	2f
	tst_NAN
	jne	1f
	tst_N
	jne	2f
1:	moveq	#0,%d0
2:	jra	fp_bsun

fp_ogl:
	moveq	#0,%d0
	tst_NAN
	jne	1f
	tst_Z
	jne	1f
	moveq	#-1,%d0
1:	jra	fp_bsun

fp_or:
	moveq	#0,%d0
	tst_NAN
	jne	1f
	moveq	#-1,%d0
1:	jra	fp_bsun

fp_un:
	moveq	#0,%d0
	tst_NAN
	jeq	1f
	moveq	#-1,%d0
	jra	fp_bsun

fp_ueq:
	moveq	#-1,%d0
	tst_NAN
	jne	1f
	tst_Z
	jne	1f
	moveq	#0,%d0
1:	jra	fp_bsun

fp_ugt:
	moveq	#-1,%d0
	tst_NAN
	jne	2f
	tst_N
	jne	1f
	tst_Z
	jeq	2f
1:	moveq	#0,%d0
2:	jra	fp_bsun

fp_uge:
	moveq	#-1,%d0
	tst_NAN
	jne	1f
	tst_Z
	jne	1f
	tst_N
	jeq	1f
	moveq	#0,%d0
1:	jra	fp_bsun

fp_ult:
	moveq	#-1,%d0
	tst_NAN
	jne	2f
	tst_Z
	jne	1f
	tst_N
	jne	2f
1:	moveq	#0,%d0
2:	jra	fp_bsun

fp_ule:
	moveq	#-1,%d0
	tst_NAN
	jne	1f
	tst_Z
	jne	1f
	tst_N
	jne	1f
	moveq	#0,%d0
1:	jra	fp_bsun

fp_ne:
	moveq	#0,%d0
	tst_Z
	jne	1f
	moveq	#-1,%d0
1:	jra	fp_bsun

fp_t:
	moveq	#-1,%d0
	jra	fp_bsun

fp_bsun:
	btst	#4,%d1
	jeq	1f
	tst_NAN
	jeq	1f
	bset	#15,%d5
	bset	#7,%d5
	move.l	%d5,(%a0)
1:	rts