#include "fp.h"

	.globl	fp_emu

	.text
fp_emu:
	bftst	(6,%sp){#0,#4}
	jeq	1f
	jmp	([fp_oldvec])
1:	clr.l	-(%sp)
	movem.l	%d0-%d7/%a0-%a6,-(%sp)
	move.l	(PC,%sp),%a5
	clr.l	fp_sr
#if 0
	clr.l	fpe_sr
	clr.l	fpe_cr
#endif
	jsr	fp_scan
	move.l	%a5,(PC,%sp)
	movem.l	(%sp)+,%d0-%d7/%a0-%a6
	addq.l	#4,%sp
	rte

#define OFF	8

	.globl	fp_get_pc, fp_put_pc
	.globl	fp_get_data_reg, fp_put_data_reg
	.globl	fp_get_addr_reg, fp_put_addr_reg
	.globl	fp_get_fpu_reg, fp_get_fpu_base

fp_get_pc:
	move.l	(OFF+PC,%sp),%a0
	P1("getting pc: %08x", %a0)
	rts

fp_put_pc:
	P1("putting pc: %08x", %a0)
	move.l	%a0,(OFF+PC,%sp)
	rts

fp_get_data_reg:
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
	.long	fp_get_d0, fp_get_d1
	.long	fp_get_d2, fp_get_d3
	.long	fp_get_d4, fp_get_d5
	.long	fp_get_d6, fp_get_d7

fp_get_d0:
	move.l	(OFF+D0,%sp),%d0
|	P1("getting d0: %08x", %d0)
	rts

fp_get_d1:
	move.l	(OFF+D1,%sp),%d0
	P1("getting d1: %08x", %d0)
	rts

fp_get_d2:
	move.l	(OFF+D2,%sp),%d0
	P1("getting d2: %08x", %d0)
	rts

fp_get_d3:
	move.l	(OFF+D3,%sp),%d0
	P1("getting d3: %08x", %d0)
	rts

fp_get_d4:
	move.l	(OFF+D4,%sp),%d0
	P1("getting d4: %08x", %d0)
	rts

fp_get_d5:
	move.l	(OFF+D5,%sp),%d0
	P1("getting d5: %08x", %d0)
	rts

fp_get_d6:
	move.l	(OFF+D6,%sp),%d0
	P1("getting d6: %08x", %d0)
	rts

fp_get_d7:
	move.l	(OFF+D7,%sp),%d0
	P1("getting d7: %08x", %d0)
	rts

fp_put_data_reg:
	jmp	([0f:w,%pc,%d1*4])

	.align	4
0:
	.long	fp_put_d0, fp_put_d1
	.long	fp_put_d2, fp_put_d3
	.long	fp_put_d4, fp_put_d5
	.long	fp_put_d6, fp_put_d7

fp_put_d0:
|	P1("putting d0: %08x", %d0)
	move.l	%d0,(OFF+D0,%sp)
	rts

fp_put_d1:
	P1("putting d1: %08x", %d0)
	move.l	%d0,(OFF+D1,%sp)
	rts

fp_put_d2:
	P1("putting d2: %08x", %d0)
	move.l	%d0,(OFF+D2,%sp)
	rts

fp_put_d3:
	P1("putting d3: %08x", %d0)
	move.l	%d0,(OFF+D3,%sp)
	rts

fp_put_d4:
	P1("putting d4: %08x", %d0)
	move.l	%d0,(OFF+D4,%sp)
	rts

fp_put_d5:
	P1("putting d5: %08x", %d0)
	move.l	%d0,(OFF+D5,%sp)
	rts

fp_put_d6:
	P1("putting d6: %08x", %d0)
	move.l	%d0,(OFF+D6,%sp)
	rts

fp_put_d7:
	P1("putting d7: %08x", %d0)
	move.l	%d0,(OFF+D7,%sp)
	rts

fp_get_addr_reg:
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
	.long	fp_get_a0, fp_get_a1
	.long	fp_get_a2, fp_get_a3
	.long	fp_get_a4, fp_get_a5
	.long	fp_get_a6, fp_get_a7

fp_get_a0:
	move.l	(OFF+A0,%sp),%a0
	P1("getting a0: %08x", %a0)
	rts

fp_get_a1:
	move.l	(OFF+A1,%sp),%a0
	P1("getting a1: %08x", %a0)
	rts

fp_get_a2:
	move.l	(OFF+A2,%sp),%a0
	P1("getting a2: %08x", %a0)
	rts

fp_get_a3:
	move.l	(OFF+A3,%sp),%a0
	P1("getting a3: %08x", %a0)
	rts

fp_get_a4:
	move.l	(OFF+A4,%sp),%a0
	P1("getting a4: %08x", %a0)
	rts

fp_get_a5:
	move.l	(OFF+A5,%sp),%a0
	P1("getting a5: %08x", %a0)
	rts

fp_get_a6:
	move.l	(OFF+A6,%sp),%a0
	P1("getting a6: %08x", %a0)
	rts

fp_get_a7:
	move.l	(OFF+A7,%sp),%a0
	P1("getting a7: %08x", %a0)
	rts

fp_put_addr_reg:
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
	.long	fp_put_a0, fp_put_a1
	.long	fp_put_a2, fp_put_a3
	.long	fp_put_a4, fp_put_a5
	.long	fp_put_a6, fp_put_a7

fp_put_a0:
	P1("putting a0: %08x", %a0)
	move.l	%a0,(OFF+A0,%sp)
	rts

fp_put_a1:
	P1("putting a1: %08x", %a0)
	move.l	%a0,(OFF+A1,%sp)
	rts

fp_put_a2:
	P1("putting a2: %08x", %a0)
	move.l	%a0,(OFF+A2,%sp)
	rts

fp_put_a3:
	P1("putting a3: %08x", %a0)
	move.l	%a0,(OFF+A3,%sp)
	rts

fp_put_a4:
	P1("putting a4: %08x", %a0)
	move.l	%a0,(OFF+A4,%sp)
	rts

fp_put_a5:
	P1("putting a5: %08x", %a0)
	move.l	%a0,(OFF+A5,%sp)
	rts

fp_put_a6:
	P1("putting a6: %08x", %a0)
	move.l	%a0,(OFF+A6,%sp)
	rts

fp_put_a7:
	P1("putting a7: %08x", %a0)
	move.l	%a0,(OFF+A7,%sp)
	rts

fp_get_fpu_reg:
	move.l	%d0,%d1
	add.l	%d0,%d0
	add.l	%d1,%d0
	lea	(fpe_reg,%d0*4),%a0
	rts

fp_get_fpu_base:
	lea	fpe_reg,%a0
	rts

	.data
	.align	4
fpe_reg:
	.extend	0,0,0,0,0,0,0,0
fpe_sr:
	.long	0
fpe_cr:
	.long	0
fpe_iar:
	.long	0

fp_sr:
	.long	0
