#include "fp.h"

	.globl	fp_fmovem_fp

| %d6 - first two instr words
| %d5 - register list and nr
| %d4 - further instr word

fp_fmovem_fp:
	P("fp_fmovem_fp")
	| get register list and count them
	btst	#11,%d6
	jne	1f
	bfextu	%d6{#24,#8},%d0		| static register list
	jra	2f
1:	bfextu	%d6{#25,#3},%d0		| dynamic register list
	jsr	fp_get_data_reg
2:	move.l	%d0,%d5
	swap	%d5
	moveq	#7,%d1
1:	lsr.l	#1,%d0
	jcc	2f
	addq.w	#1,%d5
2:	dbra	%d1,1b
	P1("registers: %08x", %d5)

	| detect address mode
	encode_addrreg(%d0)
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
	.long	fp_ill, fp_ill
	.long	fpr_indirect, fpr_postinc
	.long	fpr_predecr, fpr_disp16
	.long	fpr_extmode0, fpr_extmode1

fpr_indirect:
	encode_addrreg(%d0)
	P1("source (a%d)", %d0)
	jsr	fp_get_addr_reg
	jra	fpr_do_movem

fpr_postinc:
	btst	#13,%d6
	jne	fp_ill
	encode_addrreg(%d0)
	P1("source (a%d)+", %d0)
	jsr	fp_get_addr_reg
	move.l	%a0,%a1
	move.w	%d5,%d1
	add.w	%d5,%d5
	add.w	%d1,%d5
	lea	(%a0,%d5.w*4),%a0
	jsr	fp_put_addr_reg
	move.l	%a1,%a0
	jra	fpr_do_movem

fpr_predecr:
	btst	#13,%d6
	jeq	fp_ill
	encode_addrreg(%d0)
	P1("source -(a%d)", %d0)
	jsr	fp_get_addr_reg
	lea	(-12,%a0),%a1		| setup to addr of 1st reg to move
	neg.w	%d5
	move.w	%d5,%d1
	add.w	%d5,%d5
	add.w	%d1,%d5
	lea	(%a0,%d5.w*4),%a0
	jsr	fp_put_addr_reg
	move.l	%a1,%a0
	jra	fpr_do_movem

fpr_disp16:
	test_basereg_d16()
	jeq	1f
	btst	#13,%d6			| base register is %pc
	jne	fp_ill			| only allowed when reading from mem
#ifdef DEBUG
	moves_w	(%a5),%d0
	ext.l	%d1
	P1("base (%x,pc)",%d0)
#endif
	jsr	fp_get_pc
	jra	2f
1:	encode_addrreg(%d0)		| base register is %an
#ifdef DEBUG
	moves_w	(%a5),%d1
	ext.l	%d1
	P2("source (%x,a%d)", %d1, %d0)
#endif
	jsr	fp_get_addr_reg
2:	do_disp16(%a1, %a0)
	jra	fpr_do_movem

fpr_extmode0:
	get_extword()
	test_exttype()
	jne	fpr_fullext

	test_basereg_ext()
	jeq	1f
	btst	#13,%d6			| base register is %pc
	jne	fp_ill			| only allowed when reading from mem
	P("base pc")
	jsr	fp_get_pc
	jra	2f
1:	encode_addrreg(%d0)		| base register is %an
	P1("base a%d", %d0)
	jsr	fp_get_addr_reg
2:	move.l	%a0,%a1			| decode brief extension word
	encode_index(%d1, %d0)
	add.l	%d0,%a1
	do_disp8(%a1, %a0, %d0)
	jra	fpr_do_movem

fpr_fullext:
	sub.l	%a1,%a1
	test_basereg_ext()		| pc or an?
	jeq	1f
	btst	#13,%d6			| base register is %pc
	jne	fp_ill			| only allowed when reading from mem
	test_suppr_base()		| base register suppressed?
	jne	3f
	P("base pc")
	jsr	fp_get_pc
	jra	2f
1:	test_suppr_base()		| base register suppressed?
	jne	3f
	encode_addrreg(%d0)		| base register is %an
	P1("base a%d", %d0)
	jsr	fp_get_addr_reg
2:	move.l	%a0,%a1
#ifdef DEBUG
	jra	4f
3:	P("base register suppresed")
4:
#else
3:
#endif
	encode_basesize(%d0)
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
#ifdef DEBUG
	.long	fp_ill, fpr_base0
	.long	fpr_base16, fpr_base32

fpr_base0:
	P("no disp")
	jra	fpr_outer
#else
	.long	fp_ill, fpr_outer
	.long	fpr_base16, fpr_base32
#endif

fpr_base16:
	get_base16(%a0)
	jra	1f

fpr_base32:
	get_base32(%a0)
1:	add.l	%a0,%a1

fpr_outer:
	do_preindex(%a1, %d0)
	test_suppr_index()		| index register suppressed?
	jne	fpr_postindex
	encode_index(%d1, %d0)
	add.l	%d0,%a1

fpr_postindex:
	do_postindex(%a1)

	encode_outersize(%d0)
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
#ifdef DEBUG
	.long	fp_fullext_fin, fpr_outer0
	.long	fpr_outer16, fpr_outer32

fpr_outer0:
	P("no odisp")
	jra	fp_fullext_fin
#else
	.long	fp_fullext_fin, fp_fullext_fin
	.long	fpr_outer16, fpr_outer32
#endif

fpr_outer16:
	get_outer16(%a0)
	jra	1f

fpr_outer32:
	get_outer32(%a0)
1:	add.l	%a1,%a0
	jra	fpr_do_movem

fp_fullext_fin:
	move.l	%a1,%a0
	jra	fpr_do_movem

fpr_extmode1:
	encode_addrreg(%d0)
	jmp	([0f:w,%pc,%d0*4])

	.align	4
0:
	.long	fpr_absolute_short, fpr_absolute_long
	.long	fpr_disp16, fpr_extmode0
	.long	fp_ill, fp_ill
	.long	fp_ill, fp_ill

fpr_absolute_short:
	get_abs_short(%a0)
	jra	fpr_do_movem

fpr_absolute_long:
	get_abs_long(%a0)
	jra	fpr_do_movem

fpr_do_movem:
	move.l	%a0,%a1
	swap	%d5			| get fpu register list
	jsr	fp_get_fpu_base
	moveq	#12,%d1
#ifdef DEBUG
	btst	#12,%d6
	jne	1f
	P("decremental move")
	jra	2f
1:	P("incremental move")
2:
#endif
	btst	#12,%d6
	jne	1f
	lea	(-12,%a0,%d1*8),%a0
	neg.l	%d1
1:	btst	#13,%d6
	jne	3f
	| move register from memory into fpu
	P("cpu->fpu")
	moveq	#7,%d4
1:	lsl.b	#1,%d5
	jcc	2f
	P3("getting #%d: %p->%p", %d4, %a1, %a0)
	moves_l	(%a1)+,%d0
	clr.w	%d0
	move.l	%d0,(%a0)+
	moves_l	(%a1)+,%d0
	move.l	%d0,(%a0)+
	moves_l	(%a1),%d0
	move.l	%d0,(%a0)
	subq.l	#8,%a1
	subq.l	#8,%a0
	add.l	%d1,%a1
2:	add.l	%d1,%a0
	dbra	%d4,1b
	jra	4f
3:	| move register from fpu into memory
	P("fpu->cpu")
	moveq	#7,%d4
1:	lsl.b	#1,%d5
	jcc	2f
	P3("putting #%d: %p->%p", %d4, %a0, %a1)
	move.l	(%a0)+,%d0
	moves_l	%d0,(%a1)+
	move.l	(%a0)+,%d0
	moves_l	%d0,(%a1)+
	move.l	(%a0),%d0
	moves_l	%d0,(%a1)
	subq.l	#8,%a0
	subq.l	#8,%a1
	add.l	%d1,%a1
2:	add.l	%d1,%a0
	dbra	%d4,1b
4:
#ifdef DEBUG
	jsr	fp_get_fpu_base
	PF("fp0", (%a0))
	PF("fp1", (12,%a0))
	PF("fp2", (24,%a0))
	PF("fp3", (36,%a0))
	PF("fp4", (48,%a0))
	PF("fp5", (60,%a0))
	PF("fp6", (72,%a0))
	PF("fp7", (84,%a0))
#endif
	jra	fp_end