#include "fp.h"

	.globl	fp_ill, fp_end

fp_ill:
	P("fp_illegal")
	rts
fp_end:
	get_fpsr(%a0)
	P1("sr: %08x", (%a0))
	rts

	.globl	fp_conv_long2ext, fp_conv_single2ext
	.globl	fp_conv_double2ext, fp_conv_ext2ext

fp_conv_long2ext:
	P2("l2e: %x -> %p", %d0, %a0)
	move.w	#0x3fff+31,%a1
	tst.l	%d0
	jeq	2f
	jge	1f
	move.w	#0xbfff+31,%a1
	neg.l	%d0
1:	bfffo	%d0{#0,#32},%d1
	P1("d0: %x", %d0)
	P1("d1: %x", %d1)
	P1("a1: %x", %a1)
	sub.w	%d1,%a1
	move.w	%a1,(%a0)+
	clr.w	(%a0)+
	lsl.l	%d1,%d0
	move.l	%d0,(%a0)+
	clr.l	(%a0)
	subq.l	#8,%a0
	rts
2:	clr.l	(%a0)+
	clr.l	(%a0)+
	clr.l	(%a0)
	subq.l	#8,%a0
	rts

fp_conv_single2ext:
	bfextu	%d0{#1,#8},%d1
	jeq	2f
	cmp.w	#0xff,%d1
	jeq	3f
	add.w	#0x3fff-0x7f,%d1
	btst	#31,%d0
	jeq	1f
	bset	#15,%d1
1:	swap	%d1
	move.l	%d1,(%a0)+
	lsl.l	#8,%d0
	bset	#31,%d0
	move.l	%d0,(%a0)+
	clr.l	(%a0)
	subq.l	#8,%a0
	rts
	| zeros and denormalized
2:	move.l	%d2,-(%sp)
	btst	#31,%d0
	jeq	1f
	bset	#15,%d1
1:	lsl.l	#8,%d0
	jeq	1f
	add.w	#0x3fff-0x7f+1,%d1
	bfffo	%d0{#0,#32},%d2
	sub.l	%d2,%d1
	lsl.l	%d2,%d0
1:	swap	%d1
	move.l	%d1,(%a0)+
	move.l	%d0,(%a0)+
	clr.l	(%a0)
	subq.l	#8,%a0
	move.l	(%sp)+,%d2
	rts
	| infinitiv and NAN
3:	move.l	#0x7fff0000,%d1
	btst	#31,%d0
	jeq	1f
	bset	#31,%d1
1:	move.l	%d1,(%a0)+
	bclr	#23,%d0
	lsl.l	#8,%d0
	jeq	1f
	bset	#30,%d0
1:	move.l	%d0,(%a0)+
	clr.l	(%a0)
	subq.l	#8,%a0
	rts

fp_conv_double2ext:
	move.l	%d2,-(%sp)
	moves_l	(%a1)+,%d0
	bfextu	%d0{#1,#11},%d1
	jeq	2f
	cmp.w	#0x7ff,%d1
	jeq	5f
	add.w	#0x3fff-0x3ff,%d1
	btst	#31,%d0
	jeq	1f
	bset	#15,%d1
1:	swap	%d1
	move.l	%d1,(%a0)+
	moves_l	(%a1)+,%d1
	bfextu	%d1{#0,#11},%d2
	bfins	%d0,%d2{#1,#20}
	bset	#31,%d2
	move.l	%d2,(%a0)+
	lsl.l	#8,%d1
	lsl.l	#3,%d1
	move.l	%d1,(%a0)
	subq.l	#8,%a0	
8:	move.l	(%sp)+,%d2
	rts
	| zeros and denormalized
2:	clr.l	%d1
	bclr	#31,%d0
	jeq	1f
	bset	#31,%d1
1:	move.l	%d1,(%a0)
	addq.l	#8,%a0
	tst.l	%d0
	jne	3f
	moves_l	(%a1)+,%d1
	tst.l	%d1
	jne	1f
	clr.l	(%a0)
	clr.l	-(%a0)
	subq.l	#4,%a0
	jra	8b
1:	bfffo	%d1{#0,#32},%d0
	lsl.l	%d0,%d1
	neg.w	%d0
	add.w	#0x3fff-0x3ff-20,%d0
	clr.l	(%a0)
	move.l	%d1,-(%a0)
	swap	%d0
	add.l	%d0,-(%a0)
	jra	8b
3:	bfffo	%d0{#0,#32},%d2
	lsl.l	%d2,%d0
	moves_l	(%a1)+,%d1
	move.l	%d0,%a1
	move.l	%d1,%d0
	lsl.l	%d2,%d1
	move.l	%d1,(%a0)
	neg.w	%d2
	moveq	#0x1f,%d1
	and.l	%d2,%d1
	lsr.l	%d1,%d0
	move.l	%a1,%d1
	or.l	%d1,%d0
	move.l	%d0,-(%a0)
	add.w	#0x3fff-0x3ff+12,%d2
	swap	%d2
	add.l	%d2,-(%a0)
	jra	8b
	| infinitiv and NAN
5:	move.l	#0x7fff0000,%d1
	btst	#31,%d0
	jeq	1f
	bset	#31,%d1
1:	move.l	%d1,(%a0)+
	moves_l	(%a1)+,%d1
	bfextu	%d1{#0,#11},%d2
	bfins	%d0,%d2{#1,#20}
	lsl.l	#8,%d1
	lsl.l	#3,%d1
	jne	1f
	tst	%d2
	jeq	2f
1:	bset	#30,%d2
2:	move.l	%d2,(%a0)+
	move.l	%d1,(%a0)
	subq.l	#8,%a0
	jra	8b

fp_conv_ext2ext:
	moves_l	(%a1)+,%d0
	clr.w	%d0
	move.l	%d0,(%a0)
	swap	%d0
	move.w	#0x7fff,%d1
	and.w	%d1,%d0
	cmp.w	%d1,%d0
	jeq	5f
	moves_l	(%a1)+,%d0
	tst.l	%d0
	jeq	3f
	bfffo	%d0{#0,#32},%d1
	swap	%d1
	jne	1f
	addq.l	#4,%a0
	move.l	%d0,(%a0)+
	moves_l	(%a1)+,%d0
	move.l	%d0,(%a0)
	subq.l	#8,%a0
	rts
	| zeros and denormalized
1:	cmp.l	(%a0),%d1
	jvs	1f
	jcc	1f
	sub.l	%d1,(%a0)
	jra	2f
1:	move.l	(%a0),%d1
	and.w	#0x8000,(%a0)
2:	addq.l	#4,%a0
	swap	%d1
	lsl.l	%d1,%d0
	move.l	%d0,(%a0)+
	moves_l	(%a1)+,%d0
	move.l	%d0,%a1
	lsl.l	%d1,%d0
	move.l	%d0,(%a0)
	move.l	%a1,%d0
	neg.l	%d1
	and.w	#0x1f,%d1
	lsr.l	%d1,%d0
	or.l	%d0,-(%a0)
	subq.l	#4,%a0
	rts
3:	moves_l	(%a1)+,%d0
	bfffo	%d0{#0,#32},%d1
	add.w	#32,%d1
	swap	%d1
	cmp.l	(%a0),%d1
	jvs	1f
	jcc	1f
	sub.l	%d1,(%a0)
	jra	2f
1:	move.l	(%a0),%d1
	bclr	#31,%d1
	and.w	#0x8000,(%a0)
2:	addq.l	#8,%a0
	swap	%d1
|	P1("z2: %x", %d1)
	cmp.w	#32,%d1
	jcs	1f
	clr.l	(%a0)
	and.w	#0x1f,%d1
	lsl.l	%d1,%d0
	jra	2f
1:	move.l	%d0,%a1
	lsl.l	%d1,%d0
	move.l	%d0,(%a0)
	move.l	%a1,%d0
	neg.l	%d1
	add.w	#32,%d1
	lsr.l	%d1,%d0
2:	move.l	%d0,-(%a0)
	subq.l	#4,%a0
	rts
	| infinitiv and NAN
5:	or.w	#0x7fff,(%a0)
	addq.l	#4,%a0
	moves_l	(%a1)+,%d0
	moves_l	(%a1),%d1
	tst.l	%d1
	jne	2f
	move.l	%d0,%d1
	bclr	#31,%d1
	tst.l	%d1
	jne	1f
	clr.l	(%a0)+
	clr.l	(%a0)
	jra	3f
1:	clr.l	%d1
2:	bset	#30,%d0
	jne	1f
	bset	#6,fp_sr+2
1:	move.l	%d0,(%a0)+
	move.l	%d1,(%a0)
3:	subq.l	#8,%a0
	rts

fp_finish:
|	P1("f: %p", %a0)
	clr.l	%d0
	move.w	(%a0),%d1
	bclr	#15,%d1
	jeq	1f
	bset	#27,%d0
1:	tst.w	%d1
	jne	5f
	| zero or denormalized
	addq.l	#4,%a0
	move.l	(%a0)+,%d1
	jne	1f
	move.l	(%a0),%d1
	jne	2f
	bset	#26,%d0
	jra	8f
1:	bfffo	%d1{#0,#32},%d1
	tst.l	%d1
	jeq	8f
2:	bset	#11,%d0
	jra	8f
5:	cmp.w	#0x7fff,%d1
	jne	8f
	| infinitiv and NAN
	addq.l	#4,%a0
	move.l	(%a0)+,%d1
	bclr	#31,%d1
	tst.l	%d1
	jne	1f
	move.l	(%a0),%d1
	jne	1f
	bset	#25,%d0
	jra	8f
1:	bset	#24,%d0
8:	or.l	fp_sr,%d0
	get_fpsr(%a1)
	move.b	(3,%a1),%d0
	btst	#14,%d0
	jne	1f
	btst	#13,%d0
	jeq	2f
1:	bset	#7,%d0				| set IOP bit
2:	btst	#12,%d0
	jeq	1f
	bset	#6,%d0				| set OVFL bit
1:	btst	#11,%d0
	jeq	1f
	btst	#9,%d0
	jeq	1f
	bset	#5,%d0				| set UNFL bit
1:	btst	#10,%d0
	jeq	1f
	bset	#4,%d0				| set DZ bit
1:	btst	#12,%d0
	jne	1f
	btst	#9,%d0
	jne	1f
	btst	#8,%d0
	jeq	2f
1:	bset	#3,%d0				| set INEX bit
2:	move.l	%d0,(%a1)
	jra	fp_end
