#include <stdio.h>
#include <stdlib.h>

#define us()	({					\
	printf("unsupported at %d\n", __LINE__);	\
	exit(1);					\
})

#define s(x)	({					\
	printf("detected %s at %d\n", #x, __LINE__);	\
	exit(0);					\
})

unsigned short instr[10];

int main(int ac, char **av)
{
	unsigned short *pc = instr;
	unsigned short word1, word2, word3, rm_bit;
	int i = 0;

	if (ac < 3)
		return 1;

	for (i = 1; i < ac; i++)
		pc[i - 1] = strtol(av[i], NULL, 0);

	word1 = *pc++;
	if ((word1 & 0xfe00) == 0xf200) {
		word2 = *pc++;
		switch (word1 & 0x01c0) {
		case 0x0000:
			rm_bit = word2 & 0x4000;

			switch (word2 & 0xa000) {
			case 0x0000:
				if (rm_bit) {
					switch (word2 & 0x1c00) {
					case 0x0000:
						printf("source format: long\n");
						break;
					case 0x0400:
						printf("source format: single\n");
						break;
					case 0x0800:
						printf("source format: extended\n");
						break;
					case 0x0c00:
						printf("source format: packed\n");
						break;
					case 0x1000:
						printf("source format: word\n");
						break;
					case 0x1400:
						printf("source format: double\n");
						break;
					case 0x1800:
						printf("source format: byte\n");
						break;
					case 0x1c00:
						s(fmovecr);
						break;
					}
					switch (word1 & 0x0038) {
					case 0x0000:
						printf("source d%d\n", word1 & 0x0007);
						break;
					case 0x0008:
						s(ill);
						break;
					case 0x0010:
						printf("source (a%d)\n", word1 & 0x0007);
						break;
					case 0x0018:
						printf("source (a%d)+\n", word1 & 0x0007);
						break;
					case 0x0020:
						printf("source -(a%d)\n", word1 & 0x0007);
						break;
					case 0x0028:
						printf("source (d16,a%d)\n", word1 & 0x0007);
						break;
					case 0x0030:
						word3 = *pc++;
						if (word3 & 0x0100) {
							if (word3 & 0x0080)
								printf("base register suppresed\n");
							else
								printf("base register a%d\n", word1 & 0x0007);
							switch (word3 & 0x0030) {
							case 0x0000:
								s(ill);
								break;
							case 0x0010:
								printf("no base disp\n");
								break;
							case 0x0020:
								printf("base disp16 %x\n", *pc++);
								break;
							case 0x0030:
								printf("base disp32 %x\n",
									*((int *)pc)++);
								break;
							}
							if (word3 & 0x0003)
								if (!(word3 & 0x0004))
									printf("indirect preindexed\n");
							if (word3 & 0x0040)
								printf("index register suppresed\n");
							else
								printf("index %c%d.%c*%d\n",
									word3 & 0x8000 ? 'a' : 'd',
									(word3 & 0x7000) >> 12,
									word3 & 0x0800 ? 'l' : 'w',
									1 << ((word3 & 0x0600) >> 9));
							if (word3 & 0x0004)
								printf("indirect postindexed\n");							
							switch (word3 & 0x0003) {
							case 0x0001:
								printf("odisp0\n");
								break;
							case 0x0002:
								printf("odisp16 %x\n", *pc++);
								break;
							case 0x0003:
								printf("odisp32 %x\n",
									*((int *)pc)++);
								break;
							}
						} else {
							printf("base register a%d\n", word1 & 0x0007);
							printf("index %c%d.%c*%d\n",
								word3 & 0x8000 ? 'a' : 'd',
								(word3 & 0x7000) >> 12,
								word3 & 0x0800 ? 'l' : 'w',
								1 << ((word3 & 0x0600) >> 9));
							printf("disp8 %x\n", word3 & 0x00ff);
						}
						break;
					case 0x0038:
						switch (word1 & 0x0007) {
						case 0x0000:
							printf("absolute short at %x\n", *pc++);
							break;
						case 0x0001:
							printf("absolute long at %x\n", *((int *)pc)++);
							break;
						case 0x0002:
							printf("base register pc\n");
							printf("disp16 %x\n", *pc++);
							break;
						case 0x0003:
							printf("base register pc\n");
							word3 = *pc++;
							printf("index %c%d.%c*%d\n",
								word3 & 0x8000 ? 'a' : 'd',
								(word3 & 0x7000) >> 12,
								word3 & 0x0800 ? 'l' : 'w',
								1 << ((word3 & 0x0600) >> 9));
							if (word3 & 0x0100) {
								if (word3 & 0x0080)
									printf("base register suppresed\n");
								if (word3 & 0x0040)
									printf("index register suppresed\n");
								switch (word3 & 0x0030) {
								case 0x0000:
									s(ill);
									break;
								case 0x0010:
									printf("no disp\n");
									break;
								case 0x0020:
									printf("disp16 %x\n", *pc++);
									break;
								case 0x0030:
									printf("disp32 %x\n",
										*((int *)pc)++);
									break;
								}
								if (word3 & 0x0003) {
									if (word3 & 0x0004)
										printf("indirect postindexed\n");
									else
										printf("indirect preindexed\n");
									switch (word3 & 0x0003) {
									case 0x0001:
										printf("odisp0\n");
										break;
									case 0x0002:
										printf("odisp16 %x\n", *pc++);
										break;
									case 0x0003:
										printf("odisp32 %x\n",
											*((int *)pc)++);
										break;
									}
								}
							} else {
								printf("disp8 %x\n", word3 & 0x00ff);
							}
							break;
						case 0x0004:
							printf("immediate value #\n");
							break;
						case 0x0005:
							s(ill);
							break;
						case 0x0006:
							s(ill);
							break;
						case 0x0007:
							s(ill);
							break;
						}
						break;
					}
				} else {
					printf("source register fp%d\n", (word2 & 0x1c00) >> 10);
					if (word1 & 0x003f)
						printf("effective address should be zero\n");
				}
				printf("dest register fp%d\n", (word2 & 0x0380) >> 7);
				switch (word2 & 0x007f) {
				case 0x0000:
					s(fmove);
					break;
				case 0x0001:
					s(fint);
					break;
				case 0x0002:
					s(fsinh);
					break;
				case 0x0003:
					s(fintrz);
					break;
				case 0x0004:
					s(fsqrt);
					break;
				case 0x0005:
					us();
					break;
				case 0x0006:
					s(flognp1);
					break;
				case 0x0007:
					us();
					break;
				case 0x0008:
					s(fetoxm1);
					break;
				case 0x0009:
					s(ftanh);
					break;
				case 0x000a:
					s(fatan);
					break;
				case 0x000b:
					us();
					break;
				case 0x000c:
					s(fasin);
					break;
				case 0x000d:
					s(fatanh);
					break;
				case 0x000e:
					s(fsin);
					break;
				case 0x000f:
					s(ftan);
					break;
				case 0x0010:
					s(fetox);
					break;
				case 0x0011:
					s(ftwotox);
					break;
				case 0x0012:
					s(ftentox);
					break;
				case 0x0013:
					us();
					break;
				case 0x0014:
					s(flogn);
					break;
				case 0x0015:
					s(flog10);
					break;
				case 0x0016:
					s(flog2);
					break;
				case 0x0017:
					us();
					break;
				case 0x0018:
					s(fabs);
					break;
				case 0x0019:
					s(fcosh);
					break;
				case 0x001a:
					s(fneg);
					break;
				case 0x001b:
					us();
					break;
				case 0x001c:
					s(facos);
					break;
				case 0x001d:
					s(fcos);
					break;
				case 0x001e:
					s(fgetexp);
					break;
				case 0x001f:
					s(fgetman);
					break;
				case 0x0020:
					s(fdiv);
					break;
				case 0x0021:
					s(fmod);
					break;
				case 0x0022:
					s(fadd);
					break;
				case 0x0023:
					s(fmul);
					break;
				case 0x0024:
					s(fsgldiv);
					break;
				case 0x0025:
					s(frem);
					break;
				case 0x0026:
					s(fscale);
					break;
				case 0x0027:
					s(sglmul);
					break;
				case 0x0028:
					s(fsub);
					break;
				case 0x0029:
					us();
					break;
				case 0x002a:
					us();
					break;
				case 0x002b:
					us();
					break;
				case 0x002c:
					us();
					break;
				case 0x002d:
					us();
					break;
				case 0x002e:
					us();
					break;
				case 0x002f:
					us();
					break;
				case 0x0030:
					s(fsincos0);
					break;
				case 0x0031:
					s(fsincos1);
					break;
				case 0x0032:
					s(fsincos2);
					break;
				case 0x0033:
					s(fsincos3);
					break;
				case 0x0034:
					s(fsincos4);
					break;
				case 0x0035:
					s(fsincos5);
					break;
				case 0x0036:
					s(fsincos6);
					break;
				case 0x0037:
					s(fsincos7);
					break;
				case 0x0038:
					s(fcmp);
					break;
				case 0x0039:
					us();
					break;
				case 0x003a:
					s(ftst);
					break;
				case 0x003b:
					us();
					break;
				case 0x003c:
					us();
					break;
				case 0x003d:
					us();
					break;
				case 0x003e:
					us();
					break;
				case 0x003f:
					us();
					break;
				case 0x0040:
					s(fsmove);
					break;
				case 0x0041:
					s(fssqrt);
					break;
				case 0x0042:
					us();
					break;
				case 0x0043:
					us();
					break;
				case 0x0044:
					s(fdmove);
					break;
				case 0x0045:
					s(fdsqrt);
					break;
				case 0x0046:
					us();
					break;
				case 0x0047:
					us();
					break;
				case 0x0048:
					us();
					break;
				case 0x0049:
					us();
					break;
				case 0x004a:
					us();
					break;
				case 0x004b:
					us();
					break;
				case 0x004c:
					us();
					break;
				case 0x004d:
					us();
					break;
				case 0x004e:
					us();
					break;
				case 0x004f:
					us();
					break;
				case 0x0050:
					us();
					break;
				case 0x0051:
					us();
					break;
				case 0x0052:
					us();
					break;
				case 0x0053:
					us();
					break;
				case 0x0054:
					us();
					break;
				case 0x0055:
					us();
					break;
				case 0x0056:
					us();
					break;
				case 0x0057:
					us();
					break;
				case 0x0058:
					s(fsabs);
					break;
				case 0x0059:
					us();
					break;
				case 0x005a:
					s(fsneg);
					break;
				case 0x005b:
					us();
					break;
				case 0x005c:
					s(fdabs);
					break;
				case 0x005d:
					us();
					break;
				case 0x005e:
					s(fdneg);
					break;
				case 0x005f:
					us();
					break;
				case 0x0060:
					s(fsdiv);
					break;
				case 0x0061:
					us();
					break;
				case 0x0062:
					s(fsadd);
					break;
				case 0x0063:
					s(fsmul);
					break;
				case 0x0064:
					s(fddiv);
					break;
				case 0x0065:
					us();
					break;
				case 0x0066:
					s(fdadd);
					break;
				case 0x0067:
					s(fdmul);
					break;
				case 0x0068:
					s(fssub);
					break;
				case 0x0069:
					us();
					break;
				case 0x006a:
					us();
					break;
				case 0x006b:
					us();
					break;
				case 0x006c:
					s(fdsub);
					break;
				case 0x006d:
					us();
					break;
				case 0x006e:
					us();
					break;
				case 0x006f:
					us();
					break;
				case 0x0070:
					us();
					break;
				case 0x0071:
					us();
					break;
				case 0x0072:
					us();
					break;
				case 0x0073:
					us();
					break;
				case 0x0074:
					us();
					break;
				case 0x0075:
					us();
					break;
				case 0x0076:
					us();
					break;
				case 0x0077:
					us();
					break;
				case 0x0078:
					us();
					break;
				case 0x0079:
					us();
					break;
				case 0x007a:
					us();
					break;
				case 0x007b:
					us();
					break;
				case 0x007c:
					us();
					break;
				case 0x007d:
					us();
					break;
				case 0x007e:
					us();
					break;
				case 0x007f:
					us();
					break;
				}
				break;
			case 0x2000:
				if (rm_bit) {
					s(fmove);
				} else
					s(illegal);
				break;
			case 0x8000:
				s(fmovem);
				break;
			case 0xa000:
				s(fmovem);
				break;
			}
			break;
		case 0x0040:
			us();
			break;
		case 0x0080:
			us();
			break;
		case 0x00c0:
			us();
			break;
		case 0x0100:
			s(fsave);
			break;
		case 0x0140:
			s(frestore);
			break;
		case 0x0180:
			us();
			break;
		case 0x01c0:
			us();
			break;
		}
	} else {
		us();
	}
	us();
}